unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, DB, Forms, Controls, Graphics, Dialogs, ExtCtrls, DBCtrls,
  StdCtrls, Spin, Menus, Buttons, IniPropStorage, IniFiles, SynEdit,
  SynHighlighterSQL, ZSequence, ZDataset, ZConnection, rxdbgrid, rxdbdateedit,
  rxdbcurredit, rxspin, ZAbstractRODataset, ZSqlProcessor, ZScriptParser, DBGrids,
  LCLIntf, LCLType, Grids, EditBtn;

type

  { TForm1 }

  TForm1 = class(TForm)
    BitBtnClose: TBitBtn;
    BitBtnCreateDB: TBitBtn;
    DataSource1: TDataSource;
    DBNavigator1: TDBNavigator;
    EditItemtest1EditFormat: TEdit;
    EditItemnumeric8DisplayFormat: TEdit;
    EditItemnumeric4EditFormat: TEdit;
    EditItemnumeric4DisplayFormat: TEdit;
    EditItemtest1DisplayFormat: TEdit;
    EditItemdecimal8EditFormat: TEdit;
    EditItemdecimal8DisplayFormat: TEdit;
    EditItemdecimal4EditFormat: TEdit;
    EditItemdecimal4DisplayFormat: TEdit;
    EditItemtest2EditFormat: TEdit;
    EditItemtest2DisplayFormat: TEdit;
    EditItemnumeric8EditFormat: TEdit;
    IniPropStorFormMain: TIniPropStorage;
    Label1: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    LabelA: TLabel;
    LabelRxDBCalcEditAll: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    LabelSpin: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Panel1: TPanel;
    PanelClose: TPanel;
    Panel3: TPanel;
    PanelSQL: TPanel;
    PanelButtons: TPanel;
    RxDBCalcEditItemTest11: TRxDBCalcEdit;
    RxDBCalcEditItemDecimal8: TRxDBCalcEdit;
    RxDBCalcEditDecimal4: TRxDBCalcEdit;
    RxDBCalcEditItemTest2: TRxDBCalcEdit;
    RxDBCalcEditNumeric8: TRxDBCalcEdit;
    RxDBCalcEditItemNumeric4: TRxDBCalcEdit;
    RxDBCalcEditAll: TRxDBCalcEdit;
    RxDBCurrEditItemTest1: TRxDBCurrEdit;
    RxDBCurrEditItemDecimal8: TRxDBCurrEdit;
    RxDBCurrEditItemDecimal4: TRxDBCurrEdit;
    RxDBCurrEditItemTest2: TRxDBCurrEdit;
    RxDBCurrEditNumeric8: TRxDBCurrEdit;
    RxDBCurrEditNumeric4: TRxDBCurrEdit;
    RxDBGrid1: TRxDBGrid;
    SpinEdit1: TSpinEdit;
    Splitter1: TSplitter;
    Splitter2: TSplitter;
    SynEditCreate: TSynEdit;
    SynEditCreateTerm: TSynEdit;
    SynSQLSyn1: TSynSQLSyn;
    ZConnectionMain: TZConnection;
    ZQueryInvItems: TZQuery;
    ZQueryInvItemsINVITEMSID: TLargeintField;
    ZQueryInvItemsITEMDECIMAL4: TBCDField;
    ZQueryInvItemsITEMDECIMAL8: TZFMTBCDField;
    ZQueryInvItemsITEMNUMERIC4: TBCDField;
    ZQueryInvItemsITEMNUMERIC8: TZFMTBCDField;
    ZQueryInvItemsITEMSCREATED: TDateField;
    ZQueryInvItemsITEMSNAME: TStringField;
    ZQueryInvItemsITEMTEST1: TFloatField;
    ZQueryInvItemsITEMTEST2: TFloatField;
    ZQueryInvItemsITEMTEST3: TFloatField;
    ZQueryInvItemsITEMTEST4: TFloatField;

    ZSequence1: TZSequence;
    ZSQLProcessor1: TZSQLProcessor;

    procedure BitBtnCloseClick(Sender: TObject);
    procedure BitBtnCreateDBClick(Sender: TObject);
    procedure EditItemdecimal4DisplayFormatChange(Sender: TObject);
    procedure EditItemdecimal4EditFormatChange(Sender: TObject);
    procedure EditItemdecimal8DisplayFormatChange(Sender: TObject);
    procedure EditItemdecimal8EditFormatChange(Sender: TObject);
    procedure EditItemnumeric4DisplayFormatChange(Sender: TObject);
    procedure EditItemnumeric4EditFormatChange(Sender: TObject);
    procedure EditItemnumeric8DisplayFormatChange(Sender: TObject);
    procedure EditItemnumeric8EditFormatChange(Sender: TObject);
    procedure EditItemtest1DisplayFormatChange(Sender: TObject);
    procedure EditItemtest1EditFormatChange(Sender: TObject);
    procedure EditItemtest2DisplayFormatChange(Sender: TObject);
    procedure EditItemtest2EditFormatChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure RxDBCalcEditAllEnter(Sender: TObject);
    procedure RxDBCalcEditAllKeyPress(Sender: TObject; var Key: char);
    procedure RxDBEditMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure RxDBGrid1ColEnter(Sender: TObject);
    procedure RxDBGrid1ColExit(Sender: TObject);
    procedure RxDBGrid1KeyPress(Sender: TObject; var Key: char);
    procedure DataBaseCreate;
    procedure ZConnectionMainInit;

    function GetFrmtDecPoints(const s1: string): integer;
    function GetDecPoints(const s1: string): integer;
    function DecPointsDBGrid(const Sender: TObject): integer;
    function DecPointsCurrEdit(const Sender: TObject): integer;

    procedure SpinEdit1Change(Sender: TObject);

  private
    MyIniFile: TIniFile;
    CheckDBCalcEdit: string;
  public

  end;

var
  Form1: TForm1;
  DatabaseName: string = 'TESTOFNUMBERS.FDB';
  DatabaseProtocol: string = 'firebird';
  DatabaseUser: string = 'SYSDBA';
  DatabasePassword: string = 'masterkey';
  DatabaseCharset: string = 'UTF8';

implementation

{$R *.lfm}

{ TForm1 }


{ **************************************************************************** }
{ *  FormCreate                                                              * }
{ **************************************************************************** }
procedure TForm1.FormCreate(Sender: TObject);
begin

  MyIniFile:= TIniFile.Create('test.max');

  { Name der Datei, welche die Einstellungen speichert }
  IniPropStorFormMain.IniFileName:= Application.Title+ '.max';

  { Auch eine Möglichkeit des Zugriffs auf die Parameter }
  // (ZQueryInvItems.FieldByName('ITEMTEST1') as TZDoubleField).EditFormat:= EditItemtest1EditFormat.Text;
  ZQueryInvItemsITEMTEST1.EditFormat:= EditItemtest1EditFormat.Text;
  ZQueryInvItemsITEMTEST1.DisplayFormat:= EditItemtest1DisplayFormat.Text;

  ZQueryInvItemsITEMTEST2.DisplayFormat:= EditItemtest2DisplayFormat.Text;
  ZQueryInvItemsITEMTEST2.EditFormat:= EditItemtest2EditFormat.Text;

  { Auch eine Möglichkeit des Zugriffs auf die Parameter }
  // (ZQueryInvItems.FieldByName('ITEMDECIMAL8') as TZFMTBCDField).EditFormat:= EditItemdecimal8EditFormat.Text;
  ZQueryInvItemsITEMDECIMAL8.EditFormat:= EditItemdecimal8EditFormat.Text;
  ZQueryInvItemsITEMDECIMAL8.DisplayFormat:= EditItemdecimal8DisplayFormat.Text;

  ZQueryInvItemsITEMNUMERIC8.EditFormat:= EditItemnumeric8EditFormat.Text;
  ZQueryInvItemsITEMNUMERIC8.DisplayFormat:= EditItemnumeric8DisplayFormat.Text;

  ZQueryInvItemsITEMNUMERIC4.EditFormat:= EditItemnumeric4EditFormat.Text;
  ZQueryInvItemsITEMNUMERIC4.DisplayFormat:= EditItemnumeric4DisplayFormat.Text;

  ZQueryInvItemsITEMDECIMAL4.EditFormat:= EditItemdecimal4EditFormat.Text;
  ZQueryInvItemsITEMDECIMAL4.DisplayFormat:= EditItemdecimal4DisplayFormat.Text;

  { Muss vor dem Öffnen der Datenbank erfolgen, entfernt Währungszeichen aus dem Curr.Feld }
  DefaultFormatSettings.CurrencyString:='';
  DefaultFormatSettings.CurrencyFormat:= 0;
  // oder
  // DefaultFormatSettings.CurrencyFormat:= -1;
  // DefaultFormatSettings.CurrencyDecimals:= 2;

  // Application.ProcessMessages;

  { Sollte Datenbank nich angelegt sein, dann vorerst anlegen }
  try
    ZConnectionMainInit;
    ZQueryInvItems.Open;
    ZQueryInvItems.Refresh;
  except
    BitBtnCreateDBClick(BitBtnCreateDB);
    ZConnectionMainInit;
    ZQueryInvItems.Open;
    ZQueryInvItems.Refresh;
  end;

  DecPointsCurrEdit(RxDBCurrEditItemTest1);
  DecPointsCurrEdit(RxDBCurrEditItemTest2);
  DecPointsCurrEdit(RxDBCurrEditItemDecimal8);
  DecPointsCurrEdit(RxDBCurrEditItemDecimal4);

  DecPointsCurrEdit(RxDBCurrEditNumeric8);
  DecPointsCurrEdit(RxDBCurrEditNumeric4);




  (*
  DefaultFormatSettings : TFormatSettings = (
      CurrencyFormat: 1;
      NegCurrFormat: 5;
      ThousandSeparator: ',';
      DecimalSeparator: '.';
      CurrencyDecimals: 2;
      DateSeparator: '-';
      TimeSeparator: ':';
      ListSeparator: ',';
      CurrencyString: '$';
      ShortDateFormat: 'd/m/y';
      LongDateFormat: 'dd" "mmmm" "yyyy';
      TimeAMString: 'AM';
      TimePMString: 'PM';
      ShortTimeFormat: 'hh:nn';
      LongTimeFormat: 'hh:nn:ss';
      ShortMonthNames: ('Jan','Feb','Mar','Apr','May','Jun',
                        'Jul','Aug','Sep','Oct','Nov','Dec');
      LongMonthNames: ('January','February','March','April','May','June',
                       'July','August','September','October','November','December');
      ShortDayNames: ('Sun','Mon','Tue','Wed','Thu','Fri','Sat');
      LongDayNames:  ('Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday');
      TwoDigitYearCenturyWindow: 50;
    );
    *)
end;


{ **************************************************************************** }
{ *  EditItemtest1EditFormatChange                                           * }
{ **************************************************************************** }
procedure TForm1.EditItemtest1EditFormatChange(Sender: TObject);
var i: integer;
begin
  ZQueryInvItemsITEMTEST1.EditFormat:= EditItemtest1EditFormat.Text;
  i:= GetFrmtDecPoints(EditItemtest1EditFormat.Text);
  RxDBCurrEditItemTest1.DecimalPlaces:= i;
  ZQueryInvItems.Refresh;
end;


{ **************************************************************************** }
{ *                                                                          * }
{ **************************************************************************** }
procedure TForm1.EditItemtest1DisplayFormatChange(Sender: TObject);
begin
  ZQueryInvItemsITEMTEST1.DisplayFormat:= EditItemtest1DisplayFormat.Text;
  RxDBCurrEditItemTest1.DisplayFormat:= EditItemtest1DisplayFormat.Text;
  ZQueryInvItems.Refresh;
end;


{ **************************************************************************** }
{ *                                                                          * }
{ **************************************************************************** }
procedure TForm1.EditItemtest2DisplayFormatChange(Sender: TObject);
begin
  ZQueryInvItemsITEMTEST2.DisplayFormat:= EditItemtest2DisplayFormat.Text;
  RxDBCurrEditItemTest2.DisplayFormat:= EditItemtest2DisplayFormat.Text;
  ZQueryInvItems.Refresh;
end;


{ **************************************************************************** }
{ *                                                                          * }
{ **************************************************************************** }
procedure TForm1.EditItemtest2EditFormatChange(Sender: TObject);
var i: integer;
begin
  ZQueryInvItemsITEMTEST2.EditFormat:= EditItemtest2EditFormat.Text;
  i:= GetFrmtDecPoints(EditItemtest2EditFormat.Text);
  RxDBCurrEditItemTest2.DecimalPlaces:= i;
  ZQueryInvItems.Refresh;
end;


{ **************************************************************************** }
{ *                                                                          * }
{ **************************************************************************** }
procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  { Sollen die Fensterproperties geschrieben werden? }
  // SaveProperties(IniPropStorFormMain);
  MyIniFile.Free;
end;


{ **************************************************************************** }
{ *                                                                          * }
{ **************************************************************************** }
procedure TForm1.EditItemdecimal8EditFormatChange(Sender: TObject);
var i: integer;
begin
  ZQueryInvItemsITEMDECIMAL8.EditFormat:= EditItemdecimal8EditFormat.Text;
  i:= GetFrmtDecPoints(EditItemdecimal8EditFormat.Text);
  RxDBCurrEditItemDecimal8.DecimalPlaces:= i;
  ZQueryInvItems.Refresh;
end;


{ **************************************************************************** }
{ *                                                                          * }
{ **************************************************************************** }
procedure TForm1.EditItemnumeric4EditFormatChange(Sender: TObject);
var i: integer;
begin
  ZQueryInvItemsITEMNUMERIC4.EditFormat:= EditItemnumeric4EditFormat.Text;
  i:= GetFrmtDecPoints(EditItemnumeric4EditFormat.Text);
  RxDBCurrEditNumeric4.DecimalPlaces:= i;
  ZQueryInvItems.Refresh;
end;


{ **************************************************************************** }
{ *                                                                          * }
{ **************************************************************************** }
procedure TForm1.EditItemnumeric8EditFormatChange(Sender: TObject);
var i: integer;
begin
  ZQueryInvItemsITEMNUMERIC8.EditFormat:= EditItemnumeric8EditFormat.Text;
  i:= GetFrmtDecPoints(EditItemnumeric8EditFormat.Text);
  RxDBCurrEditNumeric8.DecimalPlaces:= i;
  ZQueryInvItems.Refresh;
end;


{ **************************************************************************** }
{ *                                                                          * }
{ **************************************************************************** }
procedure TForm1.EditItemdecimal4EditFormatChange(Sender: TObject);
var i: integer;
begin
  ZQueryInvItemsITEMDECIMAL4.EditFormat:= EditItemdecimal4EditFormat.Text;
  i:= GetFrmtDecPoints(EditItemdecimal4EditFormat.Text);
  RxDBCurrEditItemDecimal4.DecimalPlaces:= i;
  ZQueryInvItems.Refresh;
end;


{ **************************************************************************** }
{ *                                                                          * }
{ **************************************************************************** }
procedure TForm1.EditItemnumeric8DisplayFormatChange(Sender: TObject);
begin
  ZQueryInvItemsITEMNUMERIC8.DisplayFormat:= EditItemnumeric8DisplayFormat.Text;
  RxDBCurrEditNumeric8.DisplayFormat:= EditItemnumeric8DisplayFormat.Text;
  ZQueryInvItems.Refresh;
end;


{ **************************************************************************** }
{ *                                                                          * }
{ **************************************************************************** }
procedure TForm1.EditItemnumeric4DisplayFormatChange(Sender: TObject);
begin
  ZQueryInvItemsITEMNUMERIC4.DisplayFormat:= EditItemnumeric4DisplayFormat.Text;
  RxDBCurrEditNumeric4.DisplayFormat:= EditItemnumeric4DisplayFormat.Text;
  ZQueryInvItems.Refresh;
end;


{ **************************************************************************** }
{ *                                                                          * }
{ **************************************************************************** }
procedure TForm1.EditItemdecimal4DisplayFormatChange(Sender: TObject);
begin
  ZQueryInvItemsITEMDECIMAL4.DisplayFormat:= EditItemdecimal4DisplayFormat.Text;
  RxDBCurrEditItemDecimal4.DisplayFormat:= EditItemdecimal4DisplayFormat.Text;
  ZQueryInvItems.Refresh;
end;


{ **************************************************************************** }
{ *                                                                          * }
{ **************************************************************************** }
procedure TForm1.EditItemdecimal8DisplayFormatChange(Sender: TObject);
begin
  ZQueryInvItemsITEMDECIMAL8.DisplayFormat:= EditItemdecimal8DisplayFormat.Text;
  RxDBCurrEditItemDecimal8.DisplayFormat:= EditItemdecimal8DisplayFormat.Text;
  ZQueryInvItems.Refresh;
end;


{ **************************************************************************** }
{ *  ZConnectionMainInit                                                     * }
{ **************************************************************************** }
procedure TForm1.ZConnectionMainInit;
var db: string;

begin

  { Alle Werte an die ZConnection übergeben                     }
  { Pass all values to the ZConnection                          }
  with ZConnectionMain do begin

     {  Properties sicherheitshalber leeren                       }
     { Properties empty for safety                                }
     Properties.Clear;

     { Welches Datenbankprotokoll verwendet wird, hier firebird   }
     { Which database protocol is used, here firebird             }
     Protocol := DatabaseProtocol;

     { Which Database }
     db:= ExtractFilePath(Application.ExeName);
     if (RightStr(db,1)<>PathDelim) then db:= db+ PathDelim;
     db:= db+ DatabaseName;
     Database:= db;

     { User und Passwort übernehmen }
     { Take user and password       }
     User := DatabaseUser;
     Password := DatabasePassword;

     { der Charakterset der Datenbank, vorzugsweise UTF8            }
     { The character set of the database, preferably UTF8           }
     ClientCodepage:= DatabaseCharset;

     { Speicherort von fbclient.dll                                 }
     { Location of fbclient.dll                                     }
     db:= ExtractFilePath(Application.ExeName);
     if (RightStr(db,1)<>PathDelim) then db:= db+ PathDelim;
     db:= db+ 'fb464'+ PathDelim+ 'fbclient.dll';
     LibraryLocation:= db;

     //'C:\Program Files\Firebird\Firebird_4_0\fbclient.dll';  // when installed

  end;

end;


{ **************************************************************************** }
{ * PROCEDURE Database create                                                * }
{ **************************************************************************** }
procedure TForm1.DataBaseCreate;

begin

  { Datenbank wird erstellt  }
  { Database will be created }
  ZConnectionMain.Connected:= False;

  { ZConnection die eingestellten Werte zuweisen }
  { ZConnection assign the set values            }
  ZConnectionMainInit;

  { Der SQL-Befehl zum erstellen einer leeren Datenbank }
  ZConnectionMain.Properties.Add
        ('CreateNewDatabase=CREATE DATABASE ' +
        QuotedStr (DatabaseName) +
        ' USER ' + QuotedStr(DatabaseUser) +
        ' PASSWORD ' + QuotedStr(DatabasePassword) +
        ' PAGE_SIZE 8192 DEFAULT CHARACTER SET UTF8');

  { Verbinden mit der Datenbank erzeugt diese }
  { Connecting to the dahttps://sirmark.de/computer/mysql/mysql-trigger-einrichten-beispiele-zur-verwendung-von-triggern-1207.htmltabase generates this }
  ZConnectionMain.Connect;
  { und wieder schließen - close }
  ZConnectionMain.Disconnect;
  { Und Properties löschen, da ZConnection bei jedem Öffnen eine DB anlegt }
  ZConnectionMain.Properties.Clear;
end;

{ **************************************************************************** }
{ * PROCEDURE BitBtnCreateDBClick                                            * }
{ **************************************************************************** }
procedure TForm1.BitBtnCreateDBClick(Sender: TObject);
var c: char;
    s: string;
   db: string;

begin
  // Zeilenvorschub für MessageDlg
  // Linefeed for MessageDlg
  c:= #13;

  db:= ExtractFilePath(Application.ExeName);
  if (RightStr(db,1)<>PathDelim) then db:= db+ PathDelim;
  db:= db+ DatabaseName;

  // Soll die existierende Datenbank überschrieben werden?
  //  Shold existing Databas be overwritten?
  if FileExists(db) then
  begin
    s:= 'Do you wish overwrite existing Database:'+ c+ db+'?'+ c;
    if MessageDlg(s, db, mtConfirmation, [mbYes, mbNo], 0) = mrNo then
    begin
      // Msg dass die Datenbankerstellung abgebruochen wurde
      // the Database should not maked new
      ShowMessage('Database create aborted!');
      Exit;
    end;
  end;

  // Alte Datenbank löschen
  // Delete old database
  ZConnectionMain.Disconnect;
  DeleteFile(db);

  // Nur die Datenbank erstellen
  // Create Database only
  DataBaseCreate;

  // ZConnection die eingestellten Werte zuweisen
  // init new with current data
  ZConnectionMainInit;

  // Take Tables and other to Database
  begin

    // Datenbank trennen und mit den neuesten Einstellungen wieder starten
    // Disconnect database, init new with current data and start new
    ZConnectionMain.Disconnect;
    ZConnectionMainInit;
    ZConnectionMain.Connect;
    // Und die in SynEditCreateTerm gespeicherten SQL Befehle ausführen
    // Assign the data from SynEditCreate Editor to ZSQLProcessor1
    ZSQLProcessor1.Script:= SynEditCreate.Lines;
    // SQL ausführen
    // Execute SQL
    if ZSQLProcessor1.Script.Count>0 then ZSQLProcessor1.Execute;
    // Verbindung zur Datenbank trennen
    // Disconnect Database
    ZConnectionMain.Connected:= false;
    // Delimiter auf SETTERM setzen
    // Set Delimiter to SETTERM
    ZSQLProcessor1.DelimiterType:= TZDelimiterType(4);
    ZConnectionMain.Connected:= true;
    // Und die in SynEditCreateTerm gespeicherten SQL Befehle zuweisen
    // Assign the data from SynEditCreateTerm Editor to ZSQLProcessor1
    ZSQLProcessor1.Script:= SynEditCreateTerm.Lines;
    // SQL ausführen
    // Process SQL
    if ZSQLProcessor1.Script.Count>0 then ZSQLProcessor1.Execute;
    // Verbindung zur Datenbank trennen
    // Close connection to database
    ZConnectionMain.Connected:= false;
    // Delimiter auf Standardwert zurücksezten
    // Set Delimiter to standard
    ZSQLProcessor1.DelimiterType:= TZDelimiterType(0);
    ZSQLProcessor1.Script.Clear;
  end;

  { Datenbank wurde angelegt                  }
  { Database is created                       }
  if fileexists(db) = true then begin
    s:= 'Database'+ c+ db+ c+ 'is created!';
    ShowMessage(s);
  end;
  { Datenbank neu öffnen }
  ZConnectionMain.Disconnect;
  ZConnectionMainInit;
  ZConnectionMain.Connect;
  ZQueryInvItems.Open;
end;

{ **************************************************************************** }
{ *  BitBtnCloseClick                                                        * }
{ **************************************************************************** }
procedure TForm1.BitBtnCloseClick(Sender: TObject);
begin
  Close;
end;


{ **************************************************************************** }
{ *  RxDBEditMouseDown                                                       * }
{ **************************************************************************** }
procedure TForm1.RxDBEditMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  { Datenbank auf änderung einstellen }
  ZQueryInvItems.Edit;
end;

{ **************************************************************************** }
{ *  DecimalPoints                                                           * }
{ **************************************************************************** }
function TForm1.GetFrmtDecPoints(const s1: string): integer;
var i, i1: integer;
begin
  { Anzahl der Dezimalstellen im Formatstring }
  { Im Formatstring ist der Dezimaltrenner immer ein Punkt }
  i:= Pos('.', s1);
  GetFrmtDecPoints:= 0;
  { Kein Dezimaltrennzeichen im Formatstring }
  if (i=0) then exit;
  { Amnzahl der Dezimalstellen ermitteln }
  i1:= Length(s1)- i;
  { Der Rückgabewert ist die Anzahl der Dezimaltrennzeichen }
  GetFrmtDecPoints:= i1;
end;


{ **************************************************************************** }
{ *  DecimalPoints                                                           * }
{ **************************************************************************** }
function TForm1.GetDecPoints(const s1: string): integer;
var    i1: integer;
        s: string;
begin
  { Der länderspezifische Dezimaltrenner }
  s:= DefaultFormatSettings.DecimalSeparator;
  { Die Position des Dezimaltrenners suchen }
  i1:= Pos(s, s1);
  { Eruieren ob Dezimaltrenner vorhanden ist und wieviele Dezimalstellen }
  GetDecPoints:= 0;
  { Kein Dezimaltrennzeichen vorhanden, also ist 0 der Wert }
  if (i1=0) then exit;
  { Amnzahl der Dezimalstellen ermitteln }
  i1:= Length(s1)- i1;
  { Der Rückgabewert ist die Anzahl der Dezimaltrennzeichen }
  GetDecPoints:= i1;
end;


{ **************************************************************************** }
{ *  DecimalPoints                                                           * }
{ **************************************************************************** }
function TForm1.DecPointsDBGrid(const Sender: TObject): integer;
var s, s1: string;
        i: integer;

begin
  with (Sender as TRxDBGrid) do begin
    s:= SelectedField.FieldName;
    s1:= Uppercase(FieldTypeNames[(DataSource.DataSet as TZQuery).FieldByName(s).DataType]);
    if (s1='FMTBCDd') then begin
      s1:= (((DataSource.DataSet as TZQuery).FieldByName(s)) as TZFMTBCDField).EditFormat;
    end;
    if (s1='BCD') then begin
      s1:= (((DataSource.DataSet as TZQuery).FieldByName(s)) as TBCDField).EditFormat;
    end;
    if (s1='FLOAT') then begin
      s1:= (((DataSource.DataSet as TZQuery).FieldByName(s)) as TFloatField).EditFormat;
    end;
    i:= GetDecPoints(s1);
    DecPointsDBGrid:= i;
  end;
end;


{ **************************************************************************** }
{ *  DecimalPoints                                                           * }
{ **************************************************************************** }
function TForm1.DecPointsCurrEdit(const Sender: TObject): integer;
var s, s1, s2: string;
            i: integer;

begin
  with (Sender as TRxDBCurrEdit) do begin
    s:= DataField;
    s1:= Uppercase(FieldTypeNames[(DataSource.DataSet as TZQuery).FieldByName(s).DataType]);
    if (s1='FMTBCD') then begin // FMTBcd
      s1:= (((DataSource.DataSet as TZQuery).FieldByName(s)) as TFMTBCDField).EditFormat;
      s2:= (((DataSource.DataSet as TZQuery).FieldByName(s)) as TFMTBCDField).DisplayFormat;
    end;
    if (s1='BCD') then begin  // BCD
      s1:= (((DataSource.DataSet as TZQuery).FieldByName(s)) as TBCDField).EditFormat;
      s2:= (((DataSource.DataSet as TZQuery).FieldByName(s)) as TBCDField).DisplayFormat;
    end;
    if (s1='FLOAT') then begin // Float
      s1:= (((DataSource.DataSet as TZQuery).FieldByName(s)) as TFloatField).EditFormat;
      s2:= (((DataSource.DataSet as TZQuery).FieldByName(s)) as TFloatField).DisplayFormat;
    end;
    i:= GetFrmtDecPoints(s1);
    DecPointsCurrEdit:= i;
    DecimalPlaces:= i;

    //s2:= (DataSource.DataSet as TZQuery).FieldByName(s).AsString;
    DisplayFormat:= s2;
    LabelA.Caption:= s2;
  end;
end;


{ **************************************************************************** }
{ *  RxDBGrid1ColEnter                                                           * }
{ **************************************************************************** }
procedure TForm1.RxDBGrid1ColEnter(Sender: TObject);
var s, s1, fn: string;

begin

  { *** Zuweisung der Parameter der jeweiligen Spalte an RxDBCalcEdit *** }
  with (Sender as TRxDBGrid) do begin
    { Das Label des Feldes }
    LabelRxDBCalcEditAll.Caption:= SelectedField.DisplayLabel+'  ';
    { Datenbankfeldname }
    fn:= SelectedField.FieldName;

    { Welcher Feldtyp ist angeschlossen }
    s1:= Uppercase(FieldTypeNames[(DataSource.DataSet as TZQuery).FieldByName(fn).DataType]);
    { Je nach Feldtyp Editmuster auslesen }
    if (s1='FMTBCD') or (s1='BCD') or (s1='FLOAT') then begin
      // RxDBCalcEditAll.DataSource:= DataSource;
      RxDBCalcEditAll.DataField:= fn;
      RxDBCalcEditAll.Visible:= true;
      LabelRxDBCalcEditAll.Visible:= true;
    end
    { Wenn es kein numerisches Feld ist RxDBCalcEditAll nicht anzeigen }
    else begin
      RxDBCalcEditAll.Visible:= false;
      LabelRxDBCalcEditAll.Visible:= false;
    end;

   { *** Zuweisung der Anzahl der Dezimalstellen der jeweiligen Spalte an Tag *** }

   { Um die Nachkommastellen im Grid bei der Eingabe zu überprüfen }
    s:= Uppercase(FieldTypeNames[(DataSource.DataSet as TZQuery).FieldByName(fn).DataType]);

    { Falls kein Zahlenfeld gefunden wird istStandrdwert '' }
    s1:= '';

    { Falls ein Zahlenfeld die Nachkommastellen eruieren }
    case s of
      'FMTBCD': s1:= (((DataSource.DataSet as TZQuery).FieldByName(fn)) as TFMTBCDField).EditFormat;
         'BCD': s1:= (((DataSource.DataSet as TZQuery).FieldByName(fn)) as TBCDField).EditFormat;
       'FLOAT': s1:= (((DataSource.DataSet as TZQuery).FieldByName(fn)) as TFloatField).EditFormat;
    end;

    { Dezimalstellen an Tag des Feldes übergeben, ansonsten -1 für keine Dezimalzahl }
    if (s1<>'') then (DataSource.DataSet as TZQuery).FieldByName(fn).Tag:=  GetFrmtDecPoints(s1)
                else (DataSource.DataSet as TZQuery).FieldByName(fn).Tag:= -1;
  end;
end;


{ **************************************************************************** }
{ *                                                                          * }
{ **************************************************************************** }
procedure TForm1.RxDBGrid1ColExit(Sender: TObject);
begin
    //if RxDBGrid1.SelectedField.FieldName = RxDBCurrEditGrid.DataField then
    //  RxDBCurrEditGrid.Visible := False;
end;


{ **************************************************************************** }
{ *  RxDBGrid1KeyPress                                                       * }
{ **************************************************************************** }
procedure TForm1.RxDBGrid1KeyPress(Sender: TObject; var Key: char);
var     s, s2: string;
    i, i1, i2, tg: integer;
begin

  { Die beim Eintritt in RxDBCalcEdit ermittelten maximalen Kommastellen }
  s2:= (Sender as TRxDBGrid).SelectedField.FieldName;
  tg:= ((Sender as TRxDBGrid).DataSource.DataSet as TZQuery).FieldByName(s2).Tag;
  if (tg<0) then exit;

  s:= TStringCellEditor(tDBGrid(Sender).InplaceEditor).EditText;
  CheckDBCalcEdit:= s;

  { Cursorposition und ob ein Textbereich selektiert ist }
  i1:= TStringCellEditor(TDBGrid(Sender).InplaceEditor).SelStart;
  i2:= TStringCellEditor(TDBGrid(Sender).InplaceEditor).SelLength;

  { Prüfen, ob eingefügt oder ersetzt werden soll }
  if (i2>0) then Delete(s,i1,i2);
  { Ermittelt, wie der String ausschauen soll }
  Insert(Key,s,i1);

  { Ermittelt wieviele Kommastellen der zukünftige Text hat }
  i:= GetDecPoints(s);

  { Die beim Eintritt in RxDBCalcEdit ermittelten maximalen Kommastellen }
  i1:= tg+1;

  if (i>=i1) and (Key>#31) then Key:= #0;
end;


{ **************************************************************************** }
{ *  SpinEdit1Change                                                         * }
{ **************************************************************************** }
procedure TForm1.SpinEdit1Change(Sender: TObject);
var s, s1: string;
    i, i1: integer;
begin
  s:= EditItemtest1EditFormat.Text;

  { Alles nach dem Dezimalpunkt entfernen }
  i:= GetFrmtDecPoints(s);
  i1:= (Length(s)- i)+ 1;
  Delete(s, i1, i);

  { Und eingestellte Nachkommastellen annehmen }
  s1:= '000000000000000';
  i:= (Sender as TSpinEdit).Value;
  s:= s+ Copy(s1,1, i);
  EditItemtest1EditFormat.Text:= s;

  //ZQueryInvItemsITEMTEST1.Precision:= SpinEdit1.Value;
  RxDBCalcEditItemTest11.Tag:= SpinEdit1.Value;
  RxDBCurrEditItemTest1.DecimalPlaces:= SpinEdit1.Value;
  LabelSpin.Caption:= ' CurrEd.: '+ IntToStr(RxDBCurrEditItemTest1.DecimalPlaces);
  ZQueryInvItems.Refresh;
end;


{ **************************************************************************** }
{ *  RxDBCalcEditAllEnter                                                    * }
{ **************************************************************************** }
procedure TForm1.RxDBCalcEditAllEnter(Sender: TObject);
var s, s1: string;

begin
  { Angeschlossenes Datenfeld }
  s:= (Sender as TRxDBCalcEdit).DataField;

  { Das zugehörige Editmuster auslesen }
  with (Sender as TRxDBCalcEdit) do begin
    { Welcher Feldtyp ist angeschlossen }
    s1:= Uppercase(FieldTypeNames[(DataSource.DataSet as TZQuery).FieldByName(s).DataType]);
    { Je nach Feldtyp Editmuster auslesen - es geht auch Case, ja ;-)}
    if (s1='FMTBCD') then begin // FMTBcd
      s1:= (((DataSource.DataSet as TZQuery).FieldByName(s)) as TFMTBCDField).EditFormat;
    end;
    if (s1='BCD') then begin  // BCD
      s1:= (((DataSource.DataSet as TZQuery).FieldByName(s)) as TBCDField).EditFormat;
    end;
    if (s1='FLOAT') then begin // Float
      s1:= (((DataSource.DataSet as TZQuery).FieldByName(s)) as TFloatField).EditFormat;
    end;
  end;
  { Und für die Kontrolle bei der Eingabe merken }
  (Sender as TRxDBCalcEdit).Tag:= GetFrmtDecPoints(s1);
end;


{ **************************************************************************** }
{ *  RxDBCalcEditAllKeyPress                                                 * }
{ **************************************************************************** }
procedure TForm1.RxDBCalcEditAllKeyPress(Sender: TObject; var Key: char);
var i, i1, i2: integer;
            s: string;
            // y: Byte;
begin
  // y:= Byte(key); // Hier kann die Nummer einer Taste ermittelt werden
  if (key=#8) then Exit;  // Backspace

  with (Sender as TRxDBCalcEdit) do begin
    { Der momentan aktuelle Text }
    s:= Text;
    { Ermittelt wieviele Kommastellen der aktuelle Text hat }
    i:= GetDecPoints(s);
    { Die beim Eintritt in RxDBCalcEdit ermittelten maximalen Kommastellen }
    i1:= Tag;
    { Die aktuelle Position des Cursors }
    i2:= SelStart;
    { Wenn die Kommanzahl schon erreicht wurde sich der Cursor nach dem    }
    { Kommazeichen befindet dann ist keine Eingabe mehr erlaubt: Key:= #0  }
    if (i>=i1) and (i2>(Length(s)-i)-1) then Key:= #0;
  end;
end;

end.

